## ros-indigo-transmission-interface 0.9.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(transmission_interface)

# Load catkin and all dependencies required for this package
find_package(catkin REQUIRED COMPONENTS
  hardware_interface
  cmake_modules
  pluginlib
  resource_retriever
  roscpp
)

# Include a custom cmake file for TinyXML
find_package(TinyXML REQUIRED)

# Declare a catkin package
catkin_package(
  LIBRARIES
    ${PROJECT_NAME}_parser
    ${PROJECT_NAME}_loader
    ${PROJECT_NAME}_loader_plugins
  INCLUDE_DIRS
    include
  DEPENDS
    TinyXML
    pluginlib
    resource_retriever
    roscpp
)

###########
## Build ##
###########

# Build
include_directories(include ${catkin_INCLUDE_DIRS} ${TinyXML_INCLUDE_DIRS})

# Transmission parser Library
add_library(${PROJECT_NAME}_parser
  src/transmission_parser.cpp include/transmission_interface/transmission_parser.h
)
target_link_libraries(${PROJECT_NAME}_parser ${catkin_LIBRARIES} ${TinyXML_LIBRARIES})


# Transmission loader library
add_library(${PROJECT_NAME}_loader
  src/transmission_loader.cpp           include/transmission_interface/transmission_loader.h
  src/transmission_interface_loader.cpp include/transmission_interface/transmission_interface_loader.h
)
target_link_libraries(${PROJECT_NAME}_loader
  ${PROJECT_NAME}_parser
  ${catkin_LIBRARIES}
  ${TinyXML_LIBRARIES})


add_library(${PROJECT_NAME}_loader_plugins
  src/simple_transmission_loader.cpp           include/transmission_interface/simple_transmission_loader.h
  src/differential_transmission_loader.cpp     include/transmission_interface/differential_transmission_loader.h
  src/four_bar_linkage_transmission_loader.cpp include/transmission_interface/four_bar_linkage_transmission_loader.h
  src/joint_state_interface_provider.cpp       include/transmission_interface/joint_state_interface_provider.h
  src/position_joint_interface_provider.cpp    include/transmission_interface/position_joint_interface_provider.h
  src/velocity_joint_interface_provider.cpp    include/transmission_interface/velocity_joint_interface_provider.h
  src/effort_joint_interface_provider.cpp      include/transmission_interface/effort_joint_interface_provider.h)
target_link_libraries(${PROJECT_NAME}_loader_plugins ${PROJECT_NAME}_loader)


#############
## Install ##
#############

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(TARGETS ${PROJECT_NAME}_parser
                ${PROJECT_NAME}_loader
                ${PROJECT_NAME}_loader_plugins
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(FILES ros_control_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

#############
## Testing ##
#############

if(CATKIN_ENABLE_TESTING)
  catkin_add_gtest(simple_transmission_test           test/simple_transmission_test.cpp)
  catkin_add_gtest(differential_transmission_test     test/differential_transmission_test.cpp)
  catkin_add_gtest(four_bar_linkage_transmission_test test/four_bar_linkage_transmission_test.cpp)

  catkin_add_gtest(transmission_interface_test        test/transmission_interface_test.cpp)
  target_link_libraries(transmission_interface_test ${catkin_LIBRARIES} ${TinyXML_LIBRARIES})

  catkin_add_gtest(transmission_parser_test test/transmission_parser_test.cpp)
  target_link_libraries(transmission_parser_test ${PROJECT_NAME}_parser)

  catkin_add_gtest(simple_transmission_loader_test test/simple_transmission_loader_test.cpp)
  target_link_libraries(simple_transmission_loader_test ${PROJECT_NAME}_parser)

  catkin_add_gtest(differential_transmission_loader_test test/differential_transmission_loader_test.cpp)
  target_link_libraries(differential_transmission_loader_test ${PROJECT_NAME}_parser)

  catkin_add_gtest(four_bar_linkage_transmission_loader_test test/four_bar_linkage_transmission_loader_test.cpp)
  target_link_libraries(four_bar_linkage_transmission_loader_test ${PROJECT_NAME}_parser)

  catkin_add_gtest(transmission_interface_loader_test test/transmission_interface_loader_test.cpp)
  target_link_libraries(transmission_interface_loader_test ${PROJECT_NAME}_parser
                                                          transmission_interface_loader)
endif()

=== debian/changelog ===
ros-indigo-transmission-interface (0.9.7-0trusty) trusty; urgency=high

  * Introduce shared_ptr typedefs
  * Contributors: Bence Magyar

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Fri, 18 May 2018 23:00:00 -0000

ros-indigo-transmission-interface (0.9.6-0trusty) trusty; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sun, 15 Apr 2018 23:00:00 -0000

ros-indigo-transmission-interface (0.9.5-0trusty) trusty; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sun, 25 Mar 2018 23:00:00 -0000

ros-indigo-transmission-interface (0.9.4-0trusty) trusty; urgency=high

  * Clarify that hardwareInterface element is optional for actuators
  * Allow loading transmissions from a vector of TransmissionInfo instances.
  * Address -Wunused-parameter warnings
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Fri, 12 Feb 2016 00:00:00 -0000

ros-indigo-transmission-interface (0.9.3-0trusty) trusty; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Mon, 04 May 2015 23:00:00 -0000

ros-indigo-transmission-interface (0.9.2-0trusty) trusty; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sun, 03 May 2015 23:00:00 -0000

ros-indigo-transmission-interface (0.9.1-0trusty) trusty; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Mon, 03 Nov 2014 00:00:00 -0000

ros-indigo-transmission-interface (0.9.0-0trusty) trusty; urgency=high

  * Buildsystem and documentation fixes
  * Contributors: Adolfo Rodriguez Tsouroukdissian, shadowmanos

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Fri, 31 Oct 2014 00:00:00 -0000

ros-indigo-transmission-interface (0.8.2-0trusty) trusty; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Tue, 24 Jun 2014 23:00:00 -0000

ros-indigo-transmission-interface (0.8.1-0trusty) trusty; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Mon, 23 Jun 2014 23:00:00 -0000

ros-indigo-transmission-interface (0.8.0-0trusty) trusty; urgency=high

  * Add developer documentation.
  * Build script fixes.
    - Add missing libraries to catkin_package call.
    - Gate tests with CATKIN_ENABLE_TESTING.
    - Add missing files to install target.
  * Fix possible memory corruption in tests.
  * Perform sanity checks on members, not parameters.
    - The result is the same, but this is more uniform with the rest of the code.
  * Enable joint reduction spec for 4-bar linkages.
    - As in the differential transmission, it's convenient to specify an additional
    mechanical reduction on the joint output. This is especially convenient for
    flipping the rotation direction of a joint (negative reduction value).
    - Update URDF loader.
    - Update documentation and tests.
  * Trivial, cosmetic fixes.
  * C++11 compatibility fixes.
  * Fix resource check for multi-dof transmisisons.
  * Efficiency fix.
    - cppcheck flagged a [passedByValue] warning. Using const references instead.
  * Fix compiler warning.
  * Fix license header in some files.
  * Test transmission handle duplication.
  * Use less pointers in transmission loader data.
    - Only RobotHW and RobotTransmission instances are pointers as they are owned
    by the robot hardware abstraction. The rest are plain members whose lifetime
    is bound to the loader struct.
  * Trivial test addition.
  * Remove unnecessary header dependencies.
  * Catkin fixes.
  * Fix bug when adding multiple transmissions.
    - std::vectors were being used to store raw joint data, and when new transmissions
    were added, push_back()s would (potentially) reallocate the vectors and
    invalidate already stored pointers in hardware_interfaces. We now use std::map.
    - Move plugin implementations to a separate library.
    - Export link libraries to the outside.
    - More complete tests.
  * Log message change.
  * Test greceful error-out with unsupported features.
  * Add four-bar-linkage transmission parser.
  * Add differential drive transmission parser.
  * Move common XML parsing code to TransmissionLoader
    Mechanical reductions, offsets and roles are used by many transmission types.
    The TransmissionLoader base class exposes convenience methods for parsing these
    elements.
  * Remove dead code.
  * Update loader test, better log statements.
  * First draft of transmission loading.
    - Only simple transmission type currently supported.
    - Can load forward map for act->jnt state and jnt->act pos,vel.eff commands.
    - Partial testing.
  * Add class for holding transmission interfaces.
    - Mirrors hardware_interface::RobotHW, but for transmissions.
  * Allow multiple hw interfaces, Fix #112 <https://github.com/ros-controls/ros_control/issues/112>, and test.
    - Allow to specify multiple hardware interfaces for joints and actuators.
    - Fix invalid xml_element tag. Contents are now stored as a string.
    - Unit test parser.
  * Remove rosbuild artifacts. Fix #154 <https://github.com/ros-controls/ros_control/issues/154>.
  * Contributors: Adolfo Rodriguez Tsouroukdissian

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sun, 11 May 2014 23:00:00 -0000

ros-indigo-transmission-interface (0.7.2-0trusty) trusty; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Mon, 31 Mar 2014 23:00:00 -0000

ros-indigo-transmission-interface (0.7.1-0trusty) trusty; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sun, 30 Mar 2014 23:00:00 -0000

ros-indigo-transmission-interface (0.7.0-0trusty) trusty; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Fri, 28 Mar 2014 00:00:00 -0000



=== debian/control ===
Source: ros-indigo-transmission-interface
Section: misc
Priority: extra
Maintainer: Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>
Build-Depends: debhelper (>= 9.0.0), libtinyxml-dev, ros-indigo-catkin, ros-indigo-cmake-modules, ros-indigo-hardware-interface, ros-indigo-pluginlib, ros-indigo-resource-retriever, ros-indigo-roscpp
Homepage: https://github.com/ros-controls/ros_control/wiki
Standards-Version: 3.9.2

Package: ros-indigo-transmission-interface
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libtinyxml-dev, ros-indigo-pluginlib, ros-indigo-resource-retriever, ros-indigo-roscpp
Description: Transmission Interface.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-transmission-interface//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
